>From 1b54e3f04f4a6a97be111e6ce338729da2dd1e8c Mon Sep 17 00:00:00 2001
From: Simo Sorce <simo@redhat.com>
Date: Mon, 2 Jan 2012 17:10:12 -0500
Subject: [PATCH 13/15] sss_client: shared memory cache passwd map support

---
 Makefile.am                    |    1 +
 src/sss_client/nss_mc.h        |    8 ++
 src/sss_client/nss_mc_passwd.c |  217 ++++++++++++++++++++++++++++++++++++++++
 src/sss_client/nss_passwd.c    |   43 ++++++++
 4 files changed, 269 insertions(+), 0 deletions(-)
 create mode 100644 src/sss_client/nss_mc_passwd.c

diff --git a/Makefile.am b/Makefile.am
index 6ef533b7089d8bd8944f41c26ab7c492b0105b9b..ed2b56c7fceee908cd5399fd3d93dd631d009633 100644
--- a/Makefile.am
+++ b/Makefile.am
@@ -857,6 +857,7 @@ libnss_sss_la_SOURCES = \
     src/sss_client/nss_compat.h \
     src/sss_client/nss_mc_common.c \
     src/util/murmurhash3.c \
+    src/sss_client/nss_mc_passwd.c \
     src/sss_client/nss_mc.h
 libnss_sss_la_LDFLAGS = \
     -module \
diff --git a/src/sss_client/nss_mc.h b/src/sss_client/nss_mc.h
index 0bd3d3ca22def17aafb7a0dee35c9059807097fd..9c5405c45fd2e3c0463d6a478df2e71ae8701861 100644
--- a/src/sss_client/nss_mc.h
+++ b/src/sss_client/nss_mc.h
@@ -51,4 +51,12 @@ int sss_nss_mc_get_record(struct sss_cli_mc_ctx *ctx,
 int sss_nss_str_ptr_from_buffer(char **str, void **cookie,
                                 char *buf, size_t len);
 
+/* passwd db */
+int sss_nss_mc_getpwnam(const char *name,
+                        struct passwd *result,
+                        char *buffer, size_t buflen);
+int sss_nss_mc_getpwuid(uid_t uid,
+                        struct passwd *result,
+                        char *buffer, size_t buflen);
+
 #endif /* _NSS_MC_H_ */
diff --git a/src/sss_client/nss_mc_passwd.c b/src/sss_client/nss_mc_passwd.c
new file mode 100644
index 0000000000000000000000000000000000000000..e2f2c05d291925cfce07bb5c4aa617046ddc0ddc
--- /dev/null
+++ b/src/sss_client/nss_mc_passwd.c
@@ -0,0 +1,217 @@
+/*
+ * System Security Services Daemon. NSS client interface
+ *
+ * Copyright (C) Simo Sorce 2011
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU Lesser General Public License as
+ * published by the Free Software Foundation; either version 2.1 of the
+ * License, or (at your option) any later version.
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU Lesser General Public License for more details.
+ *
+ * You should have received a copy of the GNU Lesser General Public
+ * License along with this program; if not, write to the Free Software
+ * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
+ */
+
+/* PASSWD database NSS interface using mmap cache */
+
+#include <errno.h>
+#include <stdio.h>
+#include <string.h>
+#include <stdlib.h>
+#include <sys/mman.h>
+#include <time.h>
+#include "nss_mc.h"
+
+struct sss_cli_mc_ctx pw_mc_ctx = { false, -1, NULL, 0, NULL, 0, NULL, 0 };
+
+static int sss_nss_mc_parse_result(struct sss_mc_rec *rec,
+                                   struct passwd *result,
+                                   char *buffer, size_t buflen)
+{
+    struct sss_mc_pwd_data *data;
+    time_t expire;
+    void *cookie;
+    int ret;
+
+    /* additional checks before filling result*/
+    expire = rec->expire;
+    if (expire < time(NULL)) {
+        /* entry is now invalid */
+        return EINVAL;
+    }
+
+    data = (struct sss_mc_pwd_data *)rec->data;
+
+    if (data->strs_len > buflen) {
+        return ERANGE;
+    }
+
+    /* fill in glibc provided structs */
+
+    /* copy in buffer */
+    memcpy(buffer, data->strs, data->strs_len);
+
+    /* fill in passwd */
+    result->pw_uid = data->uid;
+    result->pw_gid = data->gid;
+
+    cookie = NULL;
+    ret = sss_nss_str_ptr_from_buffer(&result->pw_name, &cookie,
+                                      buffer, data->strs_len);
+    if (ret) {
+        return ret;
+    }
+    ret = sss_nss_str_ptr_from_buffer(&result->pw_passwd, &cookie,
+                                      buffer, data->strs_len);
+    if (ret) {
+        return ret;
+    }
+    ret = sss_nss_str_ptr_from_buffer(&result->pw_gecos, &cookie,
+                                      buffer, data->strs_len);
+    if (ret) {
+        return ret;
+    }
+    ret = sss_nss_str_ptr_from_buffer(&result->pw_dir, &cookie,
+                                      buffer, data->strs_len);
+    if (ret) {
+        return ret;
+    }
+    ret = sss_nss_str_ptr_from_buffer(&result->pw_shell, &cookie,
+                                      buffer, data->strs_len);
+    if (ret) {
+        return ret;
+    }
+    if (cookie != NULL) {
+        return EINVAL;
+    }
+
+    return 0;
+}
+
+int sss_nss_mc_getpwnam(const char *name,
+                        struct passwd *result,
+                        char *buffer, size_t buflen)
+{
+    struct sss_mc_rec *rec = NULL;
+    struct sss_mc_pwd_data *data;
+    char *rec_name;
+    uint32_t hash;
+    uint32_t slot;
+    int ret;
+
+    ret = sss_nss_mc_get_ctx("passwd", &pw_mc_ctx);
+    if (ret) {
+        return ret;
+    }
+
+    /* hashes are calculated including the NULL terminator */
+    hash = sss_nss_mc_hash(name, strlen(name)+1, pw_mc_ctx.ht_size);
+    slot = pw_mc_ctx.hash_table[hash];
+    if (slot > MC_SIZE_TO_SLOTS(pw_mc_ctx.dt_size)) {
+        return ENOENT;
+    }
+
+    while (slot != MC_INVALID_VAL) {
+
+        ret = sss_nss_mc_get_record(&pw_mc_ctx, slot, &rec);
+        if (ret) {
+            goto done;
+        }
+
+        /* check record matches what we are searching for */
+        if (hash != rec->hash1) {
+            /* if name hash does not match we can skip this immediately */
+            slot = rec->next;
+            continue;
+        }
+
+        data = (struct sss_mc_pwd_data *)rec->data;
+        rec_name = (char *)data + data->name;
+        if (strcmp(name, rec_name) == 0) {
+            break;
+        }
+
+        slot = rec->next;
+    }
+
+    if (slot == MC_INVALID_VAL) {
+        ret = ENOENT;
+        goto done;
+    }
+
+    ret = sss_nss_mc_parse_result(rec, result, buffer, buflen);
+
+done:
+    free(rec);
+    return ret;
+}
+
+int sss_nss_mc_getpwuid(uid_t uid,
+                        struct passwd *result,
+                        char *buffer, size_t buflen)
+{
+    struct sss_mc_rec *rec = NULL;
+    struct sss_mc_pwd_data *data;
+    char uidstr[11];
+    uint32_t hash;
+    uint32_t slot;
+    int len;
+    int ret;
+
+    ret = sss_nss_mc_get_ctx("passwd", &pw_mc_ctx);
+    if (ret) {
+        return ret;
+    }
+
+    len = snprintf(uidstr, 11, "%ld", (long)uid);
+    if (len > 10) {
+        return EINVAL;
+    }
+
+    /* hashes are calculated including the NULL terminator */
+    hash = sss_nss_mc_hash(uidstr, len+1, pw_mc_ctx.ht_size);
+    slot = pw_mc_ctx.hash_table[hash];
+    if (slot > MC_SIZE_TO_SLOTS(pw_mc_ctx.dt_size)) {
+        return ENOENT;
+    }
+
+    while (slot != MC_INVALID_VAL) {
+
+        ret = sss_nss_mc_get_record(&pw_mc_ctx, slot, &rec);
+        if (ret) {
+            goto done;
+        }
+
+        /* check record matches what we are searching for */
+        if (hash != rec->hash2) {
+            /* if uid hash does not match we can skip this immediately */
+            slot = rec->next;
+            continue;
+        }
+
+        data = (struct sss_mc_pwd_data *)rec->data;
+        if (uid == data->uid) {
+            break;
+        }
+
+        slot = rec->next;
+    }
+
+    if (slot == MC_INVALID_VAL) {
+        ret = ENOENT;
+        goto done;
+    }
+
+    ret = sss_nss_mc_parse_result(rec, result, buffer, buflen);
+
+done:
+    free(rec);
+    return ret;
+}
+
diff --git a/src/sss_client/nss_passwd.c b/src/sss_client/nss_passwd.c
index 31b9a7949d7ce72cbce3d90ed97a2d3bf655bf3f..cc0148d9a5e67608ccb9a6b4f288a45f529de5c7 100644
--- a/src/sss_client/nss_passwd.c
+++ b/src/sss_client/nss_passwd.c
@@ -28,6 +28,7 @@
 #include <stdint.h>
 #include <string.h>
 #include "sss_cli.h"
+#include "nss_mc.h"
 
 static struct sss_nss_getpwent_data {
     size_t len;
@@ -186,6 +187,27 @@ enum nss_status _nss_sss_getpwnam_r(const char *name, struct passwd *result,
     /* Caught once glibc passing in buffer == 0x0 */
     if (!buffer || !buflen) return ERANGE;
 
+    ret = sss_nss_mc_getpwnam(name, result, buffer, buflen);
+    switch (ret) {
+    case 0:
+        *errnop = 0;
+        return NSS_STATUS_SUCCESS;
+    case ERANGE:
+        *errnop = ERANGE;
+        return NSS_STATUS_TRYAGAIN;
+    case ENOENT:
+        /* fall through, we need to actively ask the parent
+         * if no entry is found */
+        break;
+    case EINVAL:
+        /* if using the mmaped cache failed,
+         * fall back to socket based comms */
+        break;
+    default:
+        *errnop = EBADMSG;
+        return NSS_STATUS_TRYAGAIN;
+    }
+
     rd.len = strlen(name) + 1;
     rd.data = name;
 
@@ -246,6 +268,27 @@ enum nss_status _nss_sss_getpwuid_r(uid_t uid, struct passwd *result,
     /* Caught once glibc passing in buffer == 0x0 */
     if (!buffer || !buflen) return ERANGE;
 
+    ret = sss_nss_mc_getpwuid(uid, result, buffer, buflen);
+    switch (ret) {
+    case 0:
+        *errnop = 0;
+        return NSS_STATUS_SUCCESS;
+    case ERANGE:
+        *errnop = ERANGE;
+        return NSS_STATUS_TRYAGAIN;
+    case ENOENT:
+        /* fall through, we need to actively ask the parent
+         * if no entry is found */
+        break;
+    case EINVAL:
+        /* if using the mmaped cache failed,
+         * fall back to socket based comms */
+        break;
+    default:
+        *errnop = EBADMSG;
+        return NSS_STATUS_TRYAGAIN;
+    }
+
     user_uid = uid;
     rd.len = sizeof(uint32_t);
     rd.data = &user_uid;
-- 
1.7.7.4